
; List package

; Universal list function
(define (foldr op k list)
  (if (null? list)
    k
    (op (car list) (foldr op k (cdr list)))
  )
)

; List sum function
(define (sum list)
  (if (null? list)
    0
    (+ (car list) (sum (cdr list)))
  )
)

; List product function
(define (product list)
  (if (null? list)
    1
    (* (car list) (product (cdr list)))
  )
)

; Integers list from a to b
(define (integers a b)
  (if (= a b)
    b
    (append a (integers (+ a 1) b))
  )
)

; List filter function
(define (filter boolexp list)
  (if (null? list)
    nil
    (if (boolexp (car list))
      (cons (car list) (filter boolexp (cdr list)))
      (filter boolexp (cdr list))
    )
  )
)

; Zermelo Frankel expressions, ex: {f(n) : bool(n); n element of L }
(define (zf f bool l)
  (map f (filter bool l))
)

