
; Evaluates <pred> and if it returns a non-null value evaluates the procedure
; o with the result of <pred> as argument. If <pred> is false returns x.
(define (apply-if pred o x)
  (if (null? pred)
    x
    (o pred)
  )
)

; o is a procedure of one argument. Map applyes o to every
; element of l returning a list of the results.
(define (map func list)
  (if (null? list)
    nil
    (cons (func (car list)) (map func (cdr list)))
  )
)

; The same as map.
(define (mapcar o l)
  (map o l)
)

; Returns a list containing the same elements of l in reverse order.
(define (reverse list)
  (if (null? list)
    nil
    (append (reverse (cdr list)) (car list))
  )
)

; Evaluates pred if its value is true evaluates all the expression.
(define (when pred exp)
  (if pred exp)
)

